program AutoRepairScarlett;
uses Windows, Messages, basswasapi;

const
  AppName = 'AutoRepairScarlett';
  PBT_APMRESUMESUSPEND = 7;
  PBT_APMRESUMEAUTOMATIC = 18;

var
  Window: HWnd;
  Message: TMsg;
  WindowClass: TWndClass;
  MyMutex: THandle;

function WindowProc(Window: HWnd; Message, WParam: Word; LParam: LongInt): LongInt; stdcall;
begin
  WindowProc := 0;
  case Message of
    WM_POWERBROADCAST: if WParam = PBT_APMRESUMESUSPEND {PBT_APMRESUMEAUTOMATIC} then
                         if BASS_WASAPI_Init(-1, 0, 0, BASS_WASAPI_EXCLUSIVE, 0, 0, nil, nil) then BASS_WASAPI_Free;
    WM_Destroy:
    begin
      PostQuitMessage(0);
      Exit
    end
  end; // case
  WindowProc := DefWindowProc(Window, Message, WParam, LParam)
end;

begin
  MyMutex := CreateMutex(nil, True, '(jx) AutoRepairScarlett "Execution_Check" Mutex');
  if GetLastError <> 0 then Halt(1);
  
  with WindowClass do
  begin
    Style := cs_HRedraw or cs_VRedraw;
    lpfnWndProc := @WindowProc;
    cbClsExtra := 0;
    cbWndExtra := 0;
    hInstance := 0;
    hIcon := LoadIcon(0, idi_Application);
    hCursor := LoadCursor(0, idc_Arrow);
    hbrBackground := GetStockObject(White_Brush);
    lpszMenuName := '';
    lpszClassName := AppName;
  end;
  if RegisterClass(WindowClass) = 0 then Halt (255);
  Window := CreateWindow(AppName, AppName, ws_OverlappedWindow, cw_UseDefault, cw_UseDefault, cw_UseDefault, cw_UseDefault, 0, 0, HInstance, nil);
//  ShowWindow(Window, CmdShow);
//  UpdateWindow(Window);

  while GetMessage(Message, 0, 0, 0) do
  begin
    TranslateMessage(Message);
    DispatchMessage(Message);
  end;
  if MyMutex <> 0 then
  begin
    ReleaseMutex(MyMutex);
    CloseHandle(MyMutex)
  end
end.
